'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var language = require('@codemirror/language');
var langJavascript = require('@codemirror/lang-javascript');
var highlight = require('@lezer/highlight');
var common = require('@lezer/common');
var lr = require('@lezer/lr');

// This file was generated by lezer-generator. You probably shouldn't edit it.
const JavascriptExpression = 1,
  Text = 2;

const percent = 37;
const closeAngle = 62;
const dash = 45;
const underscore = 95;
const openAngle = 60;
const singleQuote = 39;
const doubleQuote = 34;
const javascriptExpressionOrText = new lr.ExternalTokenizer((input, stack) => {
    let { next } = input;
    while (next !== -1) {
        if (((next === singleQuote || next === doubleQuote) &&
            input.peek(1) === openAngle &&
            input.peek(2) === percent) ||
            (next === openAngle && input.peek(1) === percent)) {
            break;
        }
        if (next === percent &&
            (([dash, underscore].indexOf(input.peek(1)) > -1 &&
                input.peek(2) === closeAngle) ||
                input.peek(1) === closeAngle)) {
            break;
        }
        next = input.advance();
    }
    if (stack.canShift(JavascriptExpression)) {
        input.acceptToken(JavascriptExpression);
    }
    else if (stack.canShift(Text)) {
        input.acceptToken(Text);
    }
}, { contextual: true });

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = lr.LRParser.deserialize({
  version: 14,
  states: "#fOYQROOPhOPOOOmQRO'#CnOOQO'#Cm'#CmOrQPO'#CmOrQPO'#CmQOQPOOPwOSO'#C_POOO)C>^)C>^O!SQPO,59YO!XQPO,59XO!^QPO,59XPOOO'#Cf'#CfP!cOSO,58yPOOO,58y,58yOOQO1G.t1G.tOOQO1G.s1G.sPOOO-E6d-E6dPOOO1G.e1G.e",
  stateData: "!n~O]OS^PQ~OQROUQOWSOXTO~O^VO~OPXO~OUQO~OS[O_[O`^O~OV_O~OW`O~OX`O~OS[O_[O`bO~O",
  goto: "ycPPPdPPPPPPgPPPPPPmpRWPQ]VRa]RUOQROQYSRZT",
  nodeNames: "⚠ JavascriptExpression Text Comment CommentContent Program OpeningTag ClosingTag Quote Quote",
  maxTerm: 18,
  nodeProps: [
    ["closedBy", 6,"ClosingTag"],
    ["openedBy", 7,"OpeningTag"]
  ],
  skippedNodes: [0,3,4,10],
  repeatNodeCount: 1,
  tokenData: "$c~R`X^!Tpq!Trs!xuv!}wx#b}!O#g!^!_#m#R#S#g#y#z!T$f$g!T#BY#BZ!T$IS$I_!T$I|$JO!T$JT$JU!T$KV$KW!T&FU&FV!T~!YY]~X^!Tpq!T#y#z!T$f$g!T#BY#BZ!T$IS$I_!T$I|$JO!T$JT$JU!T$KV$KW!T&FU&FV!T~!}OX~~#QP!`!a#T~#YPV~~~#]~#bOV~~#gOW~~#jPuv!}~#pPuv#s~#xTU~st$Xuv$^}!O$^!_!`$^#R#S$^~$^O^~~$cOU~",
  tokenizers: [1, javascriptExpressionOrText, new lr.LocalTokenGroup("!O~RSYZ_uvd}!Ow#R#Sw~dO_~~gP!`!aj~oP`~~~r~wO`~~zPuvd~", 45, 4)],
  topRules: {"Program":[0,5]},
  tokenPrec: 0
});

const ejsLanguage = language.LRLanguage.define({
    parser: parser.configure({
        props: [
            language.indentNodeProp.add({
                JavascriptExpression: language.delimitedIndent({ closing: "%>", align: false }),
            }),
            highlight.styleTags({
                "OpeningTag ClosingTag": highlight.tags.strong,
                CommentContent: highlight.tags.comment,
                Quote: highlight.tags.quote,
            }),
        ],
        wrap: common.parseMixed((node) => node.type.isTop
            ? {
                parser: langJavascript.javascriptLanguage.parser,
                overlay: (node) => node.type.name === "JavascriptExpression",
            }
            : null),
    }),
});
function ejs() {
    return new language.LanguageSupport(ejsLanguage, langJavascript.javascript().support);
}

exports.ejs = ejs;
exports.ejsLanguage = ejsLanguage;
